package cn.iocoder.byzs.module.bjdx.service.questionnaire;

import cn.hutool.core.collection.CollUtil;
import cn.iocoder.byzs.framework.common.pojo.PageResult;
import cn.iocoder.byzs.framework.common.util.object.BeanUtils;
import cn.iocoder.byzs.module.bjdx.controller.admin.questionnaire.vo.ConfigQuestionRespVO;
import cn.iocoder.byzs.module.bjdx.controller.admin.questionnaire.vo.QuestionnairePageReqVO;
import cn.iocoder.byzs.module.bjdx.controller.admin.questionnaire.vo.QuestionnaireSaveReqVO;
import cn.iocoder.byzs.module.bjdx.dal.dataobject.questionnaire.QuestionnaireDO;
import cn.iocoder.byzs.module.bjdx.dal.mysql.questionnaire.QuestionnaireMapper;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import java.util.List;
import java.util.stream.Collectors;

import static cn.iocoder.byzs.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.byzs.module.bjdx.enums.ErrorCodeConstants.QUESTIONNAIRE_NOT_EXISTS;

/**
 * 问卷 Service 实现类
 *
 * @author lyb
 */
@Service
@Validated
public class QuestionnaireServiceImpl implements QuestionnaireService {

    @Resource
    private QuestionnaireMapper questionnaireMapper;

    @Override
    public Long createQuestionnaire(QuestionnaireSaveReqVO createReqVO) {
        // 插入
        QuestionnaireDO questionnaire = BeanUtils.toBean(createReqVO, QuestionnaireDO.class);
        questionnaireMapper.insert(questionnaire);
        // 返回
        return questionnaire.getId();
    }

    @Override
    public void updateQuestionnaire(QuestionnaireSaveReqVO updateReqVO) {
        // 校验存在
        validateQuestionnaireExists(updateReqVO.getId());
        // 更新
        QuestionnaireDO updateObj = BeanUtils.toBean(updateReqVO, QuestionnaireDO.class);
        questionnaireMapper.updateById(updateObj);
    }

    @Override
    public void deleteQuestionnaire(Long id) {
        // 校验存在
        validateQuestionnaireExists(id);
        // 删除
        questionnaireMapper.deleteById(id);
    }

    @Override
        public void deleteQuestionnaireListByIds(List<Long> ids) {
        // 校验存在
        validateQuestionnaireExists(ids);
        // 删除
        questionnaireMapper.deleteByIds(ids);
        }

    private void validateQuestionnaireExists(List<Long> ids) {
        List<QuestionnaireDO> list = questionnaireMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(QUESTIONNAIRE_NOT_EXISTS);
        }
    }

    private void validateQuestionnaireExists(Long id) {
        if (questionnaireMapper.selectById(id) == null) {
            throw exception(QUESTIONNAIRE_NOT_EXISTS);
        }
    }

    @Override
    public QuestionnaireDO getQuestionnaire(Long id) {
        return questionnaireMapper.selectById(id);
    }

    @Override
    public PageResult<QuestionnaireDO> getQuestionnairePage(QuestionnairePageReqVO pageReqVO) {
        return questionnaireMapper.selectPage(pageReqVO);
    }

    @Override
    public PageResult<ConfigQuestionRespVO> getConfigQuestPage(ConfigQuestionRespVO configQuestionRespVO) {
        List<ConfigQuestionRespVO> configQuestionRespVOList = questionnaireMapper.selectConfigQuestionList(configQuestionRespVO);

        // 调用服务层方法获取分页结果
        return new PageResult<ConfigQuestionRespVO>(
                configQuestionRespVOList.stream()
                        .map(doItem -> BeanUtils.toBean(doItem, ConfigQuestionRespVO.class))
                        .collect(Collectors.toList()),
                (long) configQuestionRespVOList.size()
        );
    }

    @Override
    public PageResult<ConfigQuestionRespVO> getConfigQuestNoPage(ConfigQuestionRespVO configQuestionRespVO) {
        List<ConfigQuestionRespVO> configQuestionRespVOList = questionnaireMapper.selectConfigQuestionNoList(configQuestionRespVO);

        // 调用服务层方法获取分页结果
        return new PageResult<ConfigQuestionRespVO>(
                configQuestionRespVOList.stream()
                        .map(doItem -> BeanUtils.toBean(doItem, ConfigQuestionRespVO.class))
                        .collect(Collectors.toList()),
                (long) configQuestionRespVOList.size()
        );
    }

    @Override
    public void addConfigQuest(ConfigQuestionRespVO configQuestionRespVO) {
        questionnaireMapper.addConfigQuest(configQuestionRespVO);
    }

    @Override
    public void delConfigQuest(ConfigQuestionRespVO configQuestionRespVO) {
        questionnaireMapper.delConfigQuest(configQuestionRespVO);
    }
}